![MikroE](http://www.mikroe.com/img/designs/beta/logo_small.png)

---

# ${CLICKNAME} Click

---

- **Jira Tag**    : ${JIRA_TAG}

- **CIC Prefix**  : STEPPER4

- **Author**      : ${SW_ENG}

- **Verison**     : ${VER}

- **Date**        : ${DATE}

---
---

## Additional Documentation

---

### Library Description

${LIBRARY_DESCRIPTION}

### Examples Description

${EXAMPLE_DESCRIPTION}

### Code Snippet

${CODE_SNIPPET_INFO}

```.c
${C_CODE_SNIPPET}
```

```.bas
${B_CODE_SNIPPET}
```

```.pas
${P_CODE_SNIPPET}
```

### Additional Info and Notes

${ADDITIONAL_INFO}

### Architectures Supported

#### mikroC

| STM | KIN | CEC | MSP | TIVA | PIC | PIC32 | DSPIC | AVR | FT90x |
|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|
| ${C_STM} | ${C_KIN} | ${C_CEC} | ${C_MSP} | ${C_TIVA} | ${C_PIC} | ${C_PIC32} | ${C_DSPIC} | ${C_AVR} | ${C_FT90x} |

#### mikroBasic

| STM | KIN | CEC | MSP | TIVA | PIC | PIC32 | DSPIC | AVR | FT90x |
|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|
| ${B_STM} | ${B_KIN} | ${B_CEC} | ${B_MSP} | ${B_TIVA} | ${B_PIC} | ${B_PIC32} | ${B_DSPIC} | ${B_AVR} | ${B_FT90x} |

#### mikroPascal

| STM | KIN | CEC | MSP | TIVA | PIC | PIC32 | DSPIC | AVR | FT90x |
|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|
| ${P_STM} | ${P_KIN} | ${P_CEC} | ${P_MSP} | ${P_TIVA} | ${P_PIC} | ${P_PIC32} | ${P_DSPIC} | ${P_AVR} | ${P_FT90x} |

---
---
