#line 1 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
#line 1 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/math.h"





double fabs(double d);
double floor(double x);
double ceil(double x);
double frexp(double value, int * eptr);
double ldexp(double value, int newexp);
double modf(double val, double * iptr);
double sqrt(double x);
double atan(double f);
double asin(double x);
double acos(double x);
double atan2(double y,double x);
double sin(double f);
double cos(double f);
double tan(double x);
double exp(double x);
double log(double x);
double log10(double x);
double pow(double x, double y);
double sinh(double x);
double cosh(double x);
double tanh(double x);
#line 1 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 6 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_hal.h"
void STEPPER4_init_hal(uint16_t cpuMHz);

uint16_t STEPPER4_readMicros_hal( );

void STEPPER4_write_hal(uint8_t pin, uint8_t value);

void STEPPER4_setDirection_hal(uint8_t value);

void STEPPER4_enable_hal(uint8_t value);
#line 138 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
typedef enum
{
 STEPPER4_mif_FUNCTION = 0,
 STEPPER4_mif_DRIVER = 1,
 STEPPER4_mif_FULL2WIRE = 2,
 STEPPER4_mif_FULL3WIRE = 3,
 STEPPER4_mif_FULL4WIRE = 4,
 STEPPER4_mif_HALF3WIRE = 6,
 STEPPER4_mif_HALF4WIRE = 8

} T_STEPPER4_motor_iface;
#line 177 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_init
(
 T_STEPPER4_motor_iface ifacea,
 uint16_t mcu_freq,
 int8_t use_en_pin,
 int8_t use_inv_pin,
 int8_t enable_motor
);

void STEPPER4_init_fp
(
 void ( *fpforward )( ),
 void ( *fpbackward )( )
);
#line 208 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_move_to(int32_t absolut);
#line 216 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_move(int32_t relative);
#line 233 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run( );
#line 246 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run_speed();
#line 255 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_measure_Distancetogo ( );
#line 265 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_target_pos( );
#line 275 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_current_pos( );
#line 290 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_current_position(int32_t position);
#line 309 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_max_speed(float speed);
#line 320 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
float STEPPER4_read_max_speed( );
#line 335 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_acc(float acceleration);
#line 347 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_speed(float speed);
#line 357 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
float STEPPER4_read_speed( );
#line 368 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_measure_dist( );
#line 378 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_tar_pos( );
#line 390 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_cur_pos( );
#line 405 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_cur_pos(int32_t position);
#line 417 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_run_to_position( );
#line 425 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run_speed_to_position( );
#line 437 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_run_to_new_position (int32_t position);
#line 446 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_stop( );
#line 457 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_min_pulse_width (uint16_t width);
#line 465 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_is_running( );
#line 50 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
typedef enum
{
 STEPPER4_DIR_CCW = 0,
 STEPPER4_DIR_CW = 1

} T_STEPPER4_direction;
#line 61 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
static void ( *fpfwd )( );
static void ( *fpbkwd )( );

static uint8_t pins;

static int32_t n;
static float c0;
static float cn;
static float cmin;
static int8_t dir;
static uint8_t iface;
static uint8_t pin[ 4 ];
static int32_t pos_cur;
static int32_t pos_tar;
static float speed;
static float speed_max;
static float acc;
static float sqrt_twoa;
static uint32_t step_len;
static uint32_t st_last;
static uint16_t pw_min;

static int8_t en_inv;
static int8_t en_pin;
#line 90 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
static void compute_speed( );

static void set_out_pins(uint8_t mask);

static void set_step(int32_t step);

static void set_step0( );

static void set_step1( );

static void set_step2(int32_t step);

static void set_step3(int32_t step);

static void set_step4(int32_t step);

static void set_step6(int32_t step);

static void set_step8(int32_t step);
#line 114 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
static void compute_speed( )
{
 int32_t dis = STEPPER4_measure_dist( );
 int32_t sts = ( int32_t )( ( speed * speed ) / ( 2.0f * acc ) );

 if( dis == 0 && sts <= 1 )
 {
 step_len = 0;
 speed = 0;
 n = 0;

 return;
 }

 if( dis > 0 )
 {
 if( n > 0 )
 {
 if( ( sts >= dis ) || dir == STEPPER4_DIR_CCW )
 n = sts;
 }
 else if( n < 0 )
 {
 if( ( sts < dis ) && dir == STEPPER4_DIR_CW )
 n = -n;
 }
 }
 else if( dis < 0 ) {

 if( n > 0 )
 {
 if( ( sts >= -dis ) || dir == STEPPER4_DIR_CW )
 n = sts;
 }
 else if( n < 0 )
 {
 if( ( sts < -dis ) && dir == STEPPER4_DIR_CCW )
 n = -n;
 }
 }

 if( n == 0 )
 {
 cn = c0;
 dir = ( dis > 0 ) ? STEPPER4_DIR_CW : STEPPER4_DIR_CCW;
 }
 else {

 cn = cn - ( ( 2.0 * cn ) / ( ( 4.0 * n ) + 1 ) );
 cn =  ( ( (cn) >= (cmin) ) ? (cn) : (cmin) ) ;
 }

 n++;
 step_len = cn;
 speed = 1000000.0 / cn;

 if( dir == STEPPER4_DIR_CCW )
 speed = -speed;
}

static void set_out_pins(uint8_t mask)
{
 uint8_t i;

 for ( i = 0; i < pins; i++ )
 STEPPER4_write_hal( i, ( mask & ( 1 << i ) ) ?  1  :  0  );
}

static void step(int32_t step)
{
 switch ( iface )
 {
 case STEPPER4_mif_FUNCTION:

 set_step0();

 break;
 case STEPPER4_mif_DRIVER:

 set_step1();

 break;
 case STEPPER4_mif_FULL2WIRE:

 set_step2( step );

 break;
 case STEPPER4_mif_FULL3WIRE:

 set_step3( step );

 break;
 case STEPPER4_mif_FULL4WIRE:

 set_step4( step );

 break;
 case STEPPER4_mif_HALF3WIRE:

 set_step6( step );

 break;
 case STEPPER4_mif_HALF4WIRE:

 set_step8( step );

 break;
 }
}

static void set_step0( )
{
 if( speed > 0 )
 fpfwd();
 else
 fpbkwd();
}

static void set_step1( )
{
 set_out_pins( dir ? 0b10 : 0b00 );
 set_out_pins( dir ? 0b11 : 0b01 );

 Delay_us( 10 );

 set_out_pins( dir ? 0b10 : 0b00 );
}

static void set_step2(int32_t step)
{
 switch ( step & 0x03 )
 {
 case 0 :

 set_out_pins( 0b10 );

 break;
 case 1 :

 set_out_pins( 0b11 );

 break;
 case 2 :

 set_out_pins( 0b01 );

 break;
 case 3 :

 set_out_pins( 0b00 );

 break;
 }
}

static void set_step3(int32_t step)
{
 switch ( step % 3 )
 {
 case 0 :

 set_out_pins( 0b100 );

 break;
 case 1 :

 set_out_pins( 0b001 );

 break;
 case 2 :

 set_out_pins( 0b010 );

 break;
 }
}

static void set_step4(int32_t step)
{
 switch ( step & 0x03 )
 {
 case 0 :

 set_out_pins( 0b0101 );

 break;
 case 1 :

 set_out_pins( 0b0110 );

 break;
 case 2 :

 set_out_pins( 0b1010 );

 break;
 case 3 :

 set_out_pins( 0b1001 );

 break;
 }
}

static void set_step6(int32_t step)
{
 switch ( step % 6 )
 {
 case 0 :

 set_out_pins( 0b100 );

 break;
 case 1 :

 set_out_pins( 0b101 );

 break;
 case 2 :

 set_out_pins( 0b001 );

 break;
 case 3 :

 set_out_pins( 0b011 );

 break;
 case 4 :

 set_out_pins( 0b010 );

 break;
 case 5 :

 set_out_pins( 0b110 );

 break;
 }
}

static void set_step8(int32_t step)
{
 switch ( step & 0x07 )
 {
 case 0 :

 set_out_pins( 0b0001 );

 break;
 case 1 :

 set_out_pins( 0b0101 );

 break;
 case 2 :

 set_out_pins( 0b0100 );

 break;
 case 3 :

 set_out_pins( 0b0110 );

 break;
 case 4 :

 set_out_pins( 0b0010 );

 break;
 case 5 :

 set_out_pins( 0b1010 );

 break;
 case 6 :

 set_out_pins( 0b1000 );

 break;
 case 7:

 set_out_pins( 0b1001 );

 break;
 }
}
#line 405 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
void STEPPER4_init
(
 T_STEPPER4_motor_iface ifacea,
 uint16_t mcuFreq,
 int8_t use_en_pin,
 int8_t use_inv_pin,
 int8_t enable_motor
)
{


 STEPPER4_init_hal( mcuFreq );

 iface = ifacea;
 pos_cur = 0;
 pos_tar = 0;
 speed = 0.0;
 speed_max = 1.0;
 acc = 0.0;
 sqrt_twoa = 1.0;
 step_len = 0;
 pw_min = 1;
 st_last = 0;
 en_pin = use_en_pin;
 n = 0;
 c0 = 0.0;
 cn = 0.0;
 cmin = 1.0;
 dir = STEPPER4_DIR_CCW;

 if ( iface == STEPPER4_mif_FULL4WIRE || iface == STEPPER4_mif_HALF4WIRE )
 pins = 4;
 else if ( iface == STEPPER4_mif_FULL3WIRE || iface == STEPPER4_mif_HALF3WIRE )
 pins = 3;
 else
 pins = 2;

 if( enable_motor ) ;


 STEPPER4_set_acc( 1 );
}

void STEPPER4_init_fp(void(*fpforward )( ), void(*fpbackward)( ))
{
 fpfwd = fpforward;
 fpbkwd = fpbackward;
}

void STEPPER4_move_to(int32_t position_abs)
{
 if( pos_tar != position_abs )
 {
 pos_tar = position_abs;
 compute_speed();
 }
}

void STEPPER4_move(int32_t position_rel)
{
 STEPPER4_move_to(pos_cur + position_rel);
}

int8_t STEPPER4_run( )
{
 if( STEPPER4_run_speed() )
 compute_speed();

 return ( speed != 0.0 ) || ( STEPPER4_measure_dist( ) != 0 );
}

int8_t STEPPER4_run_speed( )
{



 uint32_t next_step_time;
 uint32_t time;

 if( !step_len )
 return  0 ;

 time = STEPPER4_readMicros_hal();
 next_step_time = st_last + step_len;
#line 491 "C:/Users/Zli_naucnik/Desktop/ME Stepper/Milan_Ignjatovic/Coding Rules and templates/Stepper_Library_V00/library/src/__STEPPER4_Lib.c"
 if( ( ( next_step_time >= st_last ) && ( ( time >= next_step_time ) || ( time < st_last ) ) ) || ( ( next_step_time < st_last ) && ( ( time >= next_step_time ) && ( time < st_last ) ) ) )
 {
 if ( dir == STEPPER4_DIR_CW )
 pos_cur += 1;
 else
 pos_cur -= 1;


 step( pos_cur );

 st_last = time;

 return  1 ;
 }
 else {

 return  0 ;
 }
}

int32_t STEPPER4_measure_dist( )
{
 return pos_tar - pos_cur;
}

int32_t STEPPER4_read_tar_pos( )
{
 return pos_tar;
}

int32_t STEPPER4_read_cur_pos()
{
 return pos_cur;
}

void STEPPER4_set_cur_pos(int32_t position)
{
 pos_tar = pos_cur = position;
 n = 0;
 step_len = 0;
 speed = 0;
}

void STEPPER4_set_max_speed(float speed)
{
 if( speed_max != speed )
 {
 speed_max = speed;
 cmin = 1000000.0 / speed;

 if( n > 0 )
 {
 n = ( int32_t )( ( speed * speed ) / ( 2.0 * acc ) );
 compute_speed();
 }
 }
}

void STEPPER4_set_acc(float acceleration)
{
 if( acc == 0.0 )
 return;

 if( acc != acceleration )
 {
 n = n * ( acc / acceleration );
 c0 = 0.676 * sqrt( 2.0 / acceleration ) * 1000000.0;
 acc = acceleration;

 compute_speed();
 }
}

void STEPPER4_set_speed(float speedf)
{
 if( speedf == speed )
 return;

 speedf =  ( (speedf)<(-speed_max) ? (-speed_max) : ( (speedf)>(speed_max) ? (speed_max) : (speedf) ) ) ;

 if( speedf == 0.0 )
 {
 step_len = 0;
 }
 else {

 step_len = fabs( 1000000.0 / speedf );
 dir = ( speedf > 0.0 ) ? STEPPER4_DIR_CW : STEPPER4_DIR_CCW;
 }

 speed = speedf;
}

float STEPPER4_read_speed( )
{
 return speed;
}

void STEPPER4_disable_outputs( )
{
 if( !iface )
 return;

 if( en_pin )
 STEPPER4_enable_hal( 0 );
 else
 return;
}

void STEPPER4_run_to_position( )
{
 while( STEPPER4_run() );
}

int8_t STEPPER4_run_speed_to_position( )
{
 if( pos_tar == pos_cur )
 return  0 ;

 if( pos_tar > pos_cur )
 dir = STEPPER4_DIR_CW;
 else
 dir = STEPPER4_DIR_CCW;

 return STEPPER4_run_speed();
}

void STEPPER4_run_to_new_position(int32_t position)
{
 STEPPER4_move_to( position );
 STEPPER4_run_to_position();
}

void STEPPER4_stop( )
{
 int32_t sts;

 if( speed != 0.0 )
 {
 sts = ( int32_t )( ( speed * speed ) / ( 2.0 * acc ) ) + 1;

 if( speed > 0 )
 STEPPER4_move( sts );
 else
 STEPPER4_move( -sts );
 }

 if( en_pin )
 STEPPER4_enable_hal( 1 );
}

void STEPPER4_set_min_pulse_width(uint16_t width)
{
 pw_min = width;
}

int8_t STEPPER4_is_running( )
{
 return !( speed == 0.0 && pos_tar == pos_cur );

}
