#include "__STEPPER4_Lib.h"

sbit STEPPER4_PIN_1 at GPIOA_ODR.B0;  // clk
sbit STEPPER4_PIN_2 at GPIOA_ODR.B4;  // dir
sbit STEPPER4_PIN_3 at GPIOD_ODR.B13; // en
sbit STEPPER4_PIN_4 at GPIOE_ODR.B4;  // rst  ne koristim ga

void sys_init( void )
{
    GPIO_Digital_Output( &GPIOA_BASE, _GPIO_PINMASK_0 );
    GPIO_Digital_Output( &GPIOA_BASE, _GPIO_PINMASK_4 );
    GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );
    GPIO_Digital_Output( &GPIOE_BASE, _GPIO_PINMASK_4 );
}

void main() 
{
   sys_init();
    STEPPER4_PIN_3 = 1;   // treba mi jer nema enable fje to moram da dodam!!!!
    STEPPER4_init( STEPPER4_mif_DRIVER, 72, false, false, true );
    STEPPER4_set_max_speed( 500.0 );
    STEPPER4_set_speed( 300.0 );
    while( 1 )
    {
       STEPPER4_run_speed();
    }
}