#line 1 "C:/Users/Zli_naucnik/Desktop/Stepper_Library_V00/example/STEPPER4_test/STEPPER4_test.c"
#line 1 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/math.h"





double fabs(double d);
double floor(double x);
double ceil(double x);
double frexp(double value, int * eptr);
double ldexp(double value, int newexp);
double modf(double val, double * iptr);
double sqrt(double x);
double atan(double f);
double asin(double x);
double acos(double x);
double atan2(double y,double x);
double sin(double f);
double cos(double f);
double tan(double x);
double exp(double x);
double log(double x);
double log10(double x);
double pow(double x, double y);
double sinh(double x);
double cosh(double x);
double tanh(double x);
#line 1 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 6 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_hal.h"
void STEPPER4_init_hal(uint16_t cpuMHz);

uint16_t STEPPER4_readMicros_hal( );

void STEPPER4_write_hal(uint8_t pin, uint8_t value);

void STEPPER4_setDirection_hal(uint8_t value);

void STEPPER4_enable_hal(uint8_t value);
#line 138 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
typedef enum
{
 STEPPER4_mif_FUNCTION = 0,
 STEPPER4_mif_DRIVER = 1,
 STEPPER4_mif_FULL2WIRE = 2,
 STEPPER4_mif_FULL3WIRE = 3,
 STEPPER4_mif_FULL4WIRE = 4,
 STEPPER4_mif_HALF3WIRE = 6,
 STEPPER4_mif_HALF4WIRE = 8

} T_STEPPER4_motor_iface;
#line 177 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_init
(
 T_STEPPER4_motor_iface ifacea,
 uint16_t mcu_freq,
 int8_t use_en_pin,
 int8_t use_inv_pin,
 int8_t enable_motor
);

void STEPPER4_init_fp
(
 void ( *fpforward )( ),
 void ( *fpbackward )( )
);
#line 208 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_move_to(int32_t absolut);
#line 216 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_move(int32_t relative);
#line 233 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run( );
#line 246 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run_speed();
#line 255 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_measure_Distancetogo ( );
#line 265 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_target_pos( );
#line 275 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_current_pos( );
#line 290 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_current_position(int32_t position);
#line 309 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_max_speed(float speed);
#line 320 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
float STEPPER4_read_max_speed( );
#line 335 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_acc(float acceleration);
#line 347 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_speed(float speed);
#line 357 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
float STEPPER4_read_speed( );
#line 368 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_measure_dist( );
#line 378 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_tar_pos( );
#line 390 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int32_t STEPPER4_read_cur_pos( );
#line 405 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_cur_pos(int32_t position);
#line 417 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_run_to_position( );
#line 425 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_run_speed_to_position( );
#line 437 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_run_to_new_position (int32_t position);
#line 446 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_stop( );
#line 457 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
void STEPPER4_set_min_pulse_width (uint16_t width);
#line 465 "c:/users/zli_naucnik/desktop/me stepper/milan_ignjatovic/coding rules and templates/stepper_library_v00/library/include/__stepper4_lib.h"
int8_t STEPPER4_is_running( );
#line 3 "C:/Users/Zli_naucnik/Desktop/Stepper_Library_V00/example/STEPPER4_test/STEPPER4_test.c"
sbit STEPPER4_PIN_1 at GPIOA_ODR.B0;
sbit STEPPER4_PIN_2 at GPIOA_ODR.B4;
sbit STEPPER4_PIN_3 at GPIOD_ODR.B13;
sbit STEPPER4_PIN_4 at GPIOE_ODR.B4;

void sys_init( void )
{
 GPIO_Digital_Output( &GPIOA_BASE, _GPIO_PINMASK_0 );
 GPIO_Digital_Output( &GPIOA_BASE, _GPIO_PINMASK_4 );
 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );
 GPIO_Digital_Output( &GPIOE_BASE, _GPIO_PINMASK_4 );
}

void main()
{
 sys_init();
 STEPPER4_PIN_3 = 1;
 STEPPER4_init( STEPPER4_mif_DRIVER, 72,  0 ,  0 ,  1  );
 STEPPER4_set_max_speed( 500.0 );
 STEPPER4_set_speed( 300.0 );
 while( 1 )
 {
 STEPPER4_run_speed();
 }
}
