__STEPPER4_Lib_compute_speed:
;__STEPPER4_Lib.c,114 :: 		static void compute_speed( )
SUB	SP, SP, #20
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,116 :: 		int32_t dis = STEPPER4_measure_dist( );
BL	_STEPPER4_measure_dist+0
; dis start address is: 32 (R8)
MOV	R8, R0
;__STEPPER4_Lib.c,117 :: 		int32_t sts = ( int32_t )( ( speed * speed ) / ( 2.0f * acc ) );
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R2, [R0, #0]
LDR	R0, [R0, #0]
BL	__Mul_FP+0
STR	R0, [SP, #12]
MOVW	R0, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_acc+0)
LDR	R2, [R0, #0]
MOV	R0, #1073741824
BL	__Mul_FP+0
STR	R0, [SP, #8]
LDR	R0, [SP, #12]
STR	R1, [SP, #4]
LDR	R1, [SP, #8]
MOV	R2, R1
BL	__Div_FP+0
LDR	R1, [SP, #4]
BL	__FloatToSignedIntegral+0
; sts start address is: 4 (R1)
MOV	R1, R0
;__STEPPER4_Lib.c,119 :: 		if( dis == 0 && sts <= 1 )
CMP	R8, #0
IT	NE
BNE	L___STEPPER4_Lib_compute_speed151
CMP	R1, #1
IT	GT
BGT	L___STEPPER4_Lib_compute_speed150
; dis end address is: 32 (R8)
; sts end address is: 4 (R1)
L___STEPPER4_Lib_compute_speed149:
;__STEPPER4_Lib.c,121 :: 		step_len = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R1, [R0, #0]
;__STEPPER4_Lib.c,122 :: 		speed = 0;
MOV	R1, #0
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R1, [R0, #0]
;__STEPPER4_Lib.c,123 :: 		n = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
STR	R1, [R0, #0]
;__STEPPER4_Lib.c,125 :: 		return;
IT	AL
BAL	L_end_compute_speed
;__STEPPER4_Lib.c,119 :: 		if( dis == 0 && sts <= 1 )
L___STEPPER4_Lib_compute_speed151:
; sts start address is: 4 (R1)
; dis start address is: 32 (R8)
L___STEPPER4_Lib_compute_speed150:
;__STEPPER4_Lib.c,128 :: 		if( dis > 0 )
CMP	R8, #0
IT	LE
BLE	L___STEPPER4_Lib_compute_speed3
;__STEPPER4_Lib.c,130 :: 		if( n > 0 )
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	LE
BLE	L___STEPPER4_Lib_compute_speed4
;__STEPPER4_Lib.c,132 :: 		if( ( sts >= dis ) || dir == STEPPER4_DIR_CCW )
CMP	R1, R8
IT	GE
BGE	L___STEPPER4_Lib_compute_speed153
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_compute_speed152
; sts end address is: 4 (R1)
IT	AL
BAL	L___STEPPER4_Lib_compute_speed7
L___STEPPER4_Lib_compute_speed153:
; sts start address is: 4 (R1)
L___STEPPER4_Lib_compute_speed152:
;__STEPPER4_Lib.c,133 :: 		n = sts;
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
STR	R1, [R0, #0]
; sts end address is: 4 (R1)
L___STEPPER4_Lib_compute_speed7:
;__STEPPER4_Lib.c,134 :: 		}
IT	AL
BAL	L___STEPPER4_Lib_compute_speed8
L___STEPPER4_Lib_compute_speed4:
;__STEPPER4_Lib.c,135 :: 		else if( n < 0 )
; sts start address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	GE
BGE	L___STEPPER4_Lib_compute_speed9
;__STEPPER4_Lib.c,137 :: 		if( ( sts < dis ) && dir == STEPPER4_DIR_CW )
CMP	R1, R8
IT	GE
BGE	L___STEPPER4_Lib_compute_speed155
; sts end address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L___STEPPER4_Lib_compute_speed154
L___STEPPER4_Lib_compute_speed147:
;__STEPPER4_Lib.c,138 :: 		n = -n;
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R1, #0]
RSBS	R0, R0, #0
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,137 :: 		if( ( sts < dis ) && dir == STEPPER4_DIR_CW )
L___STEPPER4_Lib_compute_speed155:
L___STEPPER4_Lib_compute_speed154:
;__STEPPER4_Lib.c,139 :: 		}
L___STEPPER4_Lib_compute_speed9:
L___STEPPER4_Lib_compute_speed8:
;__STEPPER4_Lib.c,140 :: 		}
IT	AL
BAL	L___STEPPER4_Lib_compute_speed13
L___STEPPER4_Lib_compute_speed3:
;__STEPPER4_Lib.c,141 :: 		else if( dis < 0 ) {
; sts start address is: 4 (R1)
CMP	R8, #0
IT	GE
BGE	L___STEPPER4_Lib_compute_speed14
;__STEPPER4_Lib.c,143 :: 		if( n > 0 )
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	LE
BLE	L___STEPPER4_Lib_compute_speed15
;__STEPPER4_Lib.c,145 :: 		if( ( sts >= -dis ) || dir == STEPPER4_DIR_CW )
RSB	R0, R8, #0
CMP	R1, R0
IT	GE
BGE	L___STEPPER4_Lib_compute_speed157
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L___STEPPER4_Lib_compute_speed156
; sts end address is: 4 (R1)
IT	AL
BAL	L___STEPPER4_Lib_compute_speed18
L___STEPPER4_Lib_compute_speed157:
; sts start address is: 4 (R1)
L___STEPPER4_Lib_compute_speed156:
;__STEPPER4_Lib.c,146 :: 		n = sts;
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
STR	R1, [R0, #0]
; sts end address is: 4 (R1)
L___STEPPER4_Lib_compute_speed18:
;__STEPPER4_Lib.c,147 :: 		}
IT	AL
BAL	L___STEPPER4_Lib_compute_speed19
L___STEPPER4_Lib_compute_speed15:
;__STEPPER4_Lib.c,148 :: 		else if( n < 0 )
; sts start address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	GE
BGE	L___STEPPER4_Lib_compute_speed20
;__STEPPER4_Lib.c,150 :: 		if( ( sts < -dis ) && dir == STEPPER4_DIR_CCW )
RSB	R0, R8, #0
CMP	R1, R0
IT	GE
BGE	L___STEPPER4_Lib_compute_speed159
; sts end address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L___STEPPER4_Lib_compute_speed158
L___STEPPER4_Lib_compute_speed145:
;__STEPPER4_Lib.c,151 :: 		n = -n;
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R1, #0]
RSBS	R0, R0, #0
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,150 :: 		if( ( sts < -dis ) && dir == STEPPER4_DIR_CCW )
L___STEPPER4_Lib_compute_speed159:
L___STEPPER4_Lib_compute_speed158:
;__STEPPER4_Lib.c,152 :: 		}
L___STEPPER4_Lib_compute_speed20:
L___STEPPER4_Lib_compute_speed19:
;__STEPPER4_Lib.c,153 :: 		}
L___STEPPER4_Lib_compute_speed14:
L___STEPPER4_Lib_compute_speed13:
;__STEPPER4_Lib.c,155 :: 		if( n == 0 )
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L___STEPPER4_Lib_compute_speed24
;__STEPPER4_Lib.c,157 :: 		cn = c0;
MOVW	R0, #lo_addr(__STEPPER4_Lib_c0+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_c0+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cn+0)
STR	R1, [R0, #0]
;__STEPPER4_Lib.c,158 :: 		dir = ( dis > 0 ) ? STEPPER4_DIR_CW : STEPPER4_DIR_CCW;
CMP	R8, #0
IT	LE
BLE	L___STEPPER4_Lib_compute_speed25
; dis end address is: 32 (R8)
; ?FLOC____STEPPER4_Lib_compute_speed?T32 start address is: 4 (R1)
MOVS	R1, #1
; ?FLOC____STEPPER4_Lib_compute_speed?T32 end address is: 4 (R1)
IT	AL
BAL	L___STEPPER4_Lib_compute_speed26
L___STEPPER4_Lib_compute_speed25:
; ?FLOC____STEPPER4_Lib_compute_speed?T32 start address is: 4 (R1)
MOVS	R1, #0
; ?FLOC____STEPPER4_Lib_compute_speed?T32 end address is: 4 (R1)
L___STEPPER4_Lib_compute_speed26:
; ?FLOC____STEPPER4_Lib_compute_speed?T32 start address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
STRB	R1, [R0, #0]
; ?FLOC____STEPPER4_Lib_compute_speed?T32 end address is: 4 (R1)
;__STEPPER4_Lib.c,159 :: 		}
IT	AL
BAL	L___STEPPER4_Lib_compute_speed27
L___STEPPER4_Lib_compute_speed24:
;__STEPPER4_Lib.c,162 :: 		cn = cn - ( ( 2.0 * cn ) / ( ( 4.0 * n ) + 1 ) );
MOVW	R0, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cn+0)
STR	R0, [SP, #16]
LDR	R2, [R0, #0]
MOV	R0, #1073741824
BL	__Mul_FP+0
STR	R0, [SP, #12]
MOVW	R0, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R0, #0]
BL	__SignedIntegralToFloat+0
MOV	R2, #1082130432
BL	__Mul_FP+0
MOV	R2, #1065353216
BL	__Add_FP+0
STR	R0, [SP, #8]
LDR	R0, [SP, #12]
STR	R1, [SP, #4]
LDR	R1, [SP, #8]
MOV	R2, R1
BL	__Div_FP+0
STR	R0, [SP, #8]
LDR	R1, [SP, #4]
LDR	R0, [SP, #16]
LDR	R0, [R0, #0]
STR	R1, [SP, #4]
LDR	R1, [SP, #8]
MOV	R2, R1
BL	__Sub_FP+0
LDR	R1, [SP, #4]
LDR	R1, [SP, #16]
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,163 :: 		cn = MAX( cn, cmin );
MOVW	R1, #lo_addr(__STEPPER4_Lib_cmin+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_cmin+0)
LDR	R2, [R1, #0]
BL	__Compare_FP+0
MOVW	R0, #0
BLT	L___STEPPER4_Lib_compute_speed178
MOVS	R0, #1
L___STEPPER4_Lib_compute_speed178:
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_compute_speed28
MOVW	R0, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cn+0)
; ?FLOC____STEPPER4_Lib_compute_speed?T40 start address is: 4 (R1)
LDR	R1, [R0, #0]
; ?FLOC____STEPPER4_Lib_compute_speed?T40 end address is: 4 (R1)
IT	AL
BAL	L___STEPPER4_Lib_compute_speed29
L___STEPPER4_Lib_compute_speed28:
MOVW	R0, #lo_addr(__STEPPER4_Lib_cmin+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cmin+0)
; ?FLOC____STEPPER4_Lib_compute_speed?T40 start address is: 4 (R1)
LDR	R1, [R0, #0]
; ?FLOC____STEPPER4_Lib_compute_speed?T40 end address is: 4 (R1)
L___STEPPER4_Lib_compute_speed29:
; ?FLOC____STEPPER4_Lib_compute_speed?T40 start address is: 4 (R1)
MOVW	R0, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cn+0)
STR	R1, [R0, #0]
; ?FLOC____STEPPER4_Lib_compute_speed?T40 end address is: 4 (R1)
;__STEPPER4_Lib.c,164 :: 		}
L___STEPPER4_Lib_compute_speed27:
;__STEPPER4_Lib.c,166 :: 		n++;
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,167 :: 		step_len = cn;
MOVW	R0, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_cn+0)
STR	R0, [SP, #8]
LDR	R0, [R0, #0]
BL	__FloatToUnsignedIntegral+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,168 :: 		speed = 1000000.0 / cn;
LDR	R0, [SP, #8]
LDR	R2, [R0, #0]
MOVW	R0, #9216
MOVT	R0, #18804
BL	__Div_FP+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,170 :: 		if( dir == STEPPER4_DIR_CCW )
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L___STEPPER4_Lib_compute_speed30
;__STEPPER4_Lib.c,171 :: 		speed = -speed;
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R0, [R1, #0]
EOR	R0, R0, #-2147483648
STR	R0, [R1, #0]
L___STEPPER4_Lib_compute_speed30:
;__STEPPER4_Lib.c,172 :: 		}
L_end_compute_speed:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of __STEPPER4_Lib_compute_speed
__STEPPER4_Lib_set_out_pins:
;__STEPPER4_Lib.c,174 :: 		static void set_out_pins(uint8_t mask)
; mask start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; mask end address is: 0 (R0)
; mask start address is: 0 (R0)
;__STEPPER4_Lib.c,178 :: 		for ( i = 0; i < pins; i++ )
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L___STEPPER4_Lib_set_out_pins31:
; i start address is: 8 (R2)
; mask start address is: 0 (R0)
; mask end address is: 0 (R0)
MOVW	R1, #lo_addr(__STEPPER4_Lib_pins+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pins+0)
LDRB	R1, [R1, #0]
CMP	R2, R1
IT	CS
BCS	L___STEPPER4_Lib_set_out_pins32
; mask end address is: 0 (R0)
;__STEPPER4_Lib.c,179 :: 		STEPPER4_write_hal( i, ( mask & ( 1 << i ) ) ? HIGH : LOW );
; mask start address is: 0 (R0)
MOVS	R1, #1
SXTH	R1, R1
LSLS	R1, R2
SXTH	R1, R1
AND	R1, R0, R1, LSL #0
SXTH	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_out_pins34
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 start address is: 4 (R1)
MOVS	R1, #1
SXTB	R1, R1
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 end address is: 4 (R1)
IT	AL
BAL	L___STEPPER4_Lib_set_out_pins35
L___STEPPER4_Lib_set_out_pins34:
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 start address is: 4 (R1)
MOVS	R1, #0
SXTB	R1, R1
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 end address is: 4 (R1)
L___STEPPER4_Lib_set_out_pins35:
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 start address is: 4 (R1)
STRB	R0, [SP, #4]
; ?FLOC____STEPPER4_Lib_set_out_pins?T51 end address is: 4 (R1)
STRB	R2, [SP, #5]
UXTB	R1, R1
UXTB	R0, R2
BL	_STEPPER4_write_hal+0
LDRB	R2, [SP, #5]
LDRB	R0, [SP, #4]
;__STEPPER4_Lib.c,178 :: 		for ( i = 0; i < pins; i++ )
ADDS	R2, R2, #1
UXTB	R2, R2
;__STEPPER4_Lib.c,179 :: 		STEPPER4_write_hal( i, ( mask & ( 1 << i ) ) ? HIGH : LOW );
; mask end address is: 0 (R0)
; i end address is: 8 (R2)
IT	AL
BAL	L___STEPPER4_Lib_set_out_pins31
L___STEPPER4_Lib_set_out_pins32:
;__STEPPER4_Lib.c,180 :: 		}
L_end_set_out_pins:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_out_pins
__STEPPER4_Lib_step:
;__STEPPER4_Lib.c,182 :: 		static void step(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,184 :: 		switch ( iface )
IT	AL
BAL	L___STEPPER4_Lib_step36
; step end address is: 0 (R0)
;__STEPPER4_Lib.c,186 :: 		case STEPPER4_mif_FUNCTION:
L___STEPPER4_Lib_step38:
;__STEPPER4_Lib.c,188 :: 		set_step0();
BL	__STEPPER4_Lib_set_step0+0
;__STEPPER4_Lib.c,190 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,191 :: 		case STEPPER4_mif_DRIVER:
L___STEPPER4_Lib_step39:
;__STEPPER4_Lib.c,193 :: 		set_step1();
BL	__STEPPER4_Lib_set_step1+0
;__STEPPER4_Lib.c,195 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,196 :: 		case STEPPER4_mif_FULL2WIRE:
L___STEPPER4_Lib_step40:
;__STEPPER4_Lib.c,198 :: 		set_step2( step );
; step start address is: 0 (R0)
; step end address is: 0 (R0)
BL	__STEPPER4_Lib_set_step2+0
;__STEPPER4_Lib.c,200 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,201 :: 		case STEPPER4_mif_FULL3WIRE:
L___STEPPER4_Lib_step41:
;__STEPPER4_Lib.c,203 :: 		set_step3( step );
; step start address is: 0 (R0)
; step end address is: 0 (R0)
BL	__STEPPER4_Lib_set_step3+0
;__STEPPER4_Lib.c,205 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,206 :: 		case STEPPER4_mif_FULL4WIRE:
L___STEPPER4_Lib_step42:
;__STEPPER4_Lib.c,208 :: 		set_step4( step );
; step start address is: 0 (R0)
; step end address is: 0 (R0)
BL	__STEPPER4_Lib_set_step4+0
;__STEPPER4_Lib.c,210 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,211 :: 		case STEPPER4_mif_HALF3WIRE:
L___STEPPER4_Lib_step43:
;__STEPPER4_Lib.c,213 :: 		set_step6( step );
; step start address is: 0 (R0)
; step end address is: 0 (R0)
BL	__STEPPER4_Lib_set_step6+0
;__STEPPER4_Lib.c,215 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,216 :: 		case STEPPER4_mif_HALF4WIRE:
L___STEPPER4_Lib_step44:
;__STEPPER4_Lib.c,218 :: 		set_step8( step );
; step start address is: 0 (R0)
; step end address is: 0 (R0)
BL	__STEPPER4_Lib_set_step8+0
;__STEPPER4_Lib.c,220 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_step37
;__STEPPER4_Lib.c,221 :: 		}
L___STEPPER4_Lib_step36:
; step start address is: 0 (R0)
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_step38
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_step39
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_step40
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #3
IT	EQ
BEQ	L___STEPPER4_Lib_step41
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #4
IT	EQ
BEQ	L___STEPPER4_Lib_step42
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #6
IT	EQ
BEQ	L___STEPPER4_Lib_step43
MOVW	R1, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R1, [R1, #0]
CMP	R1, #8
IT	EQ
BEQ	L___STEPPER4_Lib_step44
; step end address is: 0 (R0)
L___STEPPER4_Lib_step37:
;__STEPPER4_Lib.c,222 :: 		}
L_end_step:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __STEPPER4_Lib_step
__STEPPER4_Lib_set_step0:
;__STEPPER4_Lib.c,224 :: 		static void set_step0( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,226 :: 		if( speed > 0 )
MOVW	R4, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R5, [R4, #0]
MOV	R4, #0
MOV	R2, R4
MOV	R0, R5
BL	__Compare_FP+0
MOVW	R0, #0
BLE	L___STEPPER4_Lib_set_step0182
MOVS	R0, #1
L___STEPPER4_Lib_set_step0182:
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step045
;__STEPPER4_Lib.c,227 :: 		fpfwd();
MOVW	R4, #lo_addr(__STEPPER4_Lib_fpfwd+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_fpfwd+0)
LDR	R4, [R4, #0]
BLX	R4
IT	AL
BAL	L___STEPPER4_Lib_set_step046
L___STEPPER4_Lib_set_step045:
;__STEPPER4_Lib.c,229 :: 		fpbkwd();
MOVW	R4, #lo_addr(__STEPPER4_Lib_fpbkwd+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_fpbkwd+0)
LDR	R4, [R4, #0]
BLX	R4
L___STEPPER4_Lib_set_step046:
;__STEPPER4_Lib.c,230 :: 		}
L_end_set_step0:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __STEPPER4_Lib_set_step0
__STEPPER4_Lib_set_step1:
;__STEPPER4_Lib.c,232 :: 		static void set_step1( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,234 :: 		set_out_pins( dir ? 0b10 : 0b00 );
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step147
; ?FLOC____STEPPER4_Lib_set_step1?T60 start address is: 0 (R0)
MOVS	R0, #2
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T60 end address is: 0 (R0)
IT	AL
BAL	L___STEPPER4_Lib_set_step148
L___STEPPER4_Lib_set_step147:
; ?FLOC____STEPPER4_Lib_set_step1?T60 start address is: 0 (R0)
MOVS	R0, #0
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T60 end address is: 0 (R0)
L___STEPPER4_Lib_set_step148:
; ?FLOC____STEPPER4_Lib_set_step1?T60 start address is: 0 (R0)
UXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T60 end address is: 0 (R0)
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,235 :: 		set_out_pins( dir ? 0b11 : 0b01 );
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step149
; ?FLOC____STEPPER4_Lib_set_step1?T61 start address is: 0 (R0)
MOVS	R0, #3
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T61 end address is: 0 (R0)
IT	AL
BAL	L___STEPPER4_Lib_set_step150
L___STEPPER4_Lib_set_step149:
; ?FLOC____STEPPER4_Lib_set_step1?T61 start address is: 0 (R0)
MOVS	R0, #1
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T61 end address is: 0 (R0)
L___STEPPER4_Lib_set_step150:
; ?FLOC____STEPPER4_Lib_set_step1?T61 start address is: 0 (R0)
UXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T61 end address is: 0 (R0)
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,237 :: 		Delay_us( 10 );
MOVW	R7, #119
MOVT	R7, #0
NOP
NOP
L___STEPPER4_Lib_set_step151:
SUBS	R7, R7, #1
BNE	L___STEPPER4_Lib_set_step151
NOP
NOP
NOP
;__STEPPER4_Lib.c,239 :: 		set_out_pins( dir ? 0b10 : 0b00 );
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step153
; ?FLOC____STEPPER4_Lib_set_step1?T62 start address is: 0 (R0)
MOVS	R0, #2
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T62 end address is: 0 (R0)
IT	AL
BAL	L___STEPPER4_Lib_set_step154
L___STEPPER4_Lib_set_step153:
; ?FLOC____STEPPER4_Lib_set_step1?T62 start address is: 0 (R0)
MOVS	R0, #0
SXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T62 end address is: 0 (R0)
L___STEPPER4_Lib_set_step154:
; ?FLOC____STEPPER4_Lib_set_step1?T62 start address is: 0 (R0)
UXTB	R0, R0
; ?FLOC____STEPPER4_Lib_set_step1?T62 end address is: 0 (R0)
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,240 :: 		}
L_end_set_step1:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __STEPPER4_Lib_set_step1
__STEPPER4_Lib_set_step2:
;__STEPPER4_Lib.c,242 :: 		static void set_step2(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,244 :: 		switch ( step & 0x03 )
AND	R1, R0, #3
; step end address is: 0 (R0)
STR	R1, [SP, #4]
IT	AL
BAL	L___STEPPER4_Lib_set_step255
;__STEPPER4_Lib.c,246 :: 		case 0 :
L___STEPPER4_Lib_set_step257:
;__STEPPER4_Lib.c,248 :: 		set_out_pins( 0b10 );
MOVS	R0, #2
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,250 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step256
;__STEPPER4_Lib.c,251 :: 		case 1 :
L___STEPPER4_Lib_set_step258:
;__STEPPER4_Lib.c,253 :: 		set_out_pins( 0b11 );
MOVS	R0, #3
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,255 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step256
;__STEPPER4_Lib.c,256 :: 		case 2 :
L___STEPPER4_Lib_set_step259:
;__STEPPER4_Lib.c,258 :: 		set_out_pins( 0b01 );
MOVS	R0, #1
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,260 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step256
;__STEPPER4_Lib.c,261 :: 		case 3 :
L___STEPPER4_Lib_set_step260:
;__STEPPER4_Lib.c,263 :: 		set_out_pins( 0b00 );
MOVS	R0, #0
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,265 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step256
;__STEPPER4_Lib.c,266 :: 		}
L___STEPPER4_Lib_set_step255:
LDR	R1, [SP, #4]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step257
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_set_step258
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_set_step259
CMP	R1, #3
IT	EQ
BEQ	L___STEPPER4_Lib_set_step260
L___STEPPER4_Lib_set_step256:
;__STEPPER4_Lib.c,267 :: 		}
L_end_set_step2:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_step2
__STEPPER4_Lib_set_step3:
;__STEPPER4_Lib.c,269 :: 		static void set_step3(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,271 :: 		switch ( step % 3 )
MOVS	R2, #3
SDIV	R1, R0, R2
MLS	R1, R2, R1, R0
; step end address is: 0 (R0)
STR	R1, [SP, #4]
IT	AL
BAL	L___STEPPER4_Lib_set_step361
;__STEPPER4_Lib.c,273 :: 		case 0 :
L___STEPPER4_Lib_set_step363:
;__STEPPER4_Lib.c,275 :: 		set_out_pins( 0b100 );
MOVS	R0, #4
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,277 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step362
;__STEPPER4_Lib.c,278 :: 		case 1 :
L___STEPPER4_Lib_set_step364:
;__STEPPER4_Lib.c,280 :: 		set_out_pins( 0b001 );
MOVS	R0, #1
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,282 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step362
;__STEPPER4_Lib.c,283 :: 		case 2 :
L___STEPPER4_Lib_set_step365:
;__STEPPER4_Lib.c,285 :: 		set_out_pins( 0b010 );
MOVS	R0, #2
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,287 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step362
;__STEPPER4_Lib.c,288 :: 		}
L___STEPPER4_Lib_set_step361:
LDR	R1, [SP, #4]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step363
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_set_step364
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_set_step365
L___STEPPER4_Lib_set_step362:
;__STEPPER4_Lib.c,289 :: 		}
L_end_set_step3:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_step3
__STEPPER4_Lib_set_step4:
;__STEPPER4_Lib.c,291 :: 		static void set_step4(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,293 :: 		switch ( step & 0x03 )
AND	R1, R0, #3
; step end address is: 0 (R0)
STR	R1, [SP, #4]
IT	AL
BAL	L___STEPPER4_Lib_set_step466
;__STEPPER4_Lib.c,295 :: 		case 0 :
L___STEPPER4_Lib_set_step468:
;__STEPPER4_Lib.c,297 :: 		set_out_pins( 0b0101 );
MOVS	R0, #5
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,299 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step467
;__STEPPER4_Lib.c,300 :: 		case 1 :
L___STEPPER4_Lib_set_step469:
;__STEPPER4_Lib.c,302 :: 		set_out_pins( 0b0110 );
MOVS	R0, #6
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,304 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step467
;__STEPPER4_Lib.c,305 :: 		case 2 :
L___STEPPER4_Lib_set_step470:
;__STEPPER4_Lib.c,307 :: 		set_out_pins( 0b1010 );
MOVS	R0, #10
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,309 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step467
;__STEPPER4_Lib.c,310 :: 		case 3 :
L___STEPPER4_Lib_set_step471:
;__STEPPER4_Lib.c,312 :: 		set_out_pins( 0b1001 );
MOVS	R0, #9
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,314 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step467
;__STEPPER4_Lib.c,315 :: 		}
L___STEPPER4_Lib_set_step466:
LDR	R1, [SP, #4]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step468
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_set_step469
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_set_step470
CMP	R1, #3
IT	EQ
BEQ	L___STEPPER4_Lib_set_step471
L___STEPPER4_Lib_set_step467:
;__STEPPER4_Lib.c,316 :: 		}
L_end_set_step4:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_step4
__STEPPER4_Lib_set_step6:
;__STEPPER4_Lib.c,318 :: 		static void set_step6(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,320 :: 		switch ( step % 6 )
MOVS	R2, #6
SDIV	R1, R0, R2
MLS	R1, R2, R1, R0
; step end address is: 0 (R0)
STR	R1, [SP, #4]
IT	AL
BAL	L___STEPPER4_Lib_set_step672
;__STEPPER4_Lib.c,322 :: 		case 0 :
L___STEPPER4_Lib_set_step674:
;__STEPPER4_Lib.c,324 :: 		set_out_pins( 0b100 );
MOVS	R0, #4
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,326 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,327 :: 		case 1 :
L___STEPPER4_Lib_set_step675:
;__STEPPER4_Lib.c,329 :: 		set_out_pins( 0b101 );
MOVS	R0, #5
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,331 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,332 :: 		case 2 :
L___STEPPER4_Lib_set_step676:
;__STEPPER4_Lib.c,334 :: 		set_out_pins( 0b001 );
MOVS	R0, #1
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,336 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,337 :: 		case 3 :
L___STEPPER4_Lib_set_step677:
;__STEPPER4_Lib.c,339 :: 		set_out_pins( 0b011 );
MOVS	R0, #3
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,341 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,342 :: 		case 4 :
L___STEPPER4_Lib_set_step678:
;__STEPPER4_Lib.c,344 :: 		set_out_pins( 0b010 );
MOVS	R0, #2
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,346 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,347 :: 		case 5 :
L___STEPPER4_Lib_set_step679:
;__STEPPER4_Lib.c,349 :: 		set_out_pins( 0b110 );
MOVS	R0, #6
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,351 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step673
;__STEPPER4_Lib.c,352 :: 		}
L___STEPPER4_Lib_set_step672:
LDR	R1, [SP, #4]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step674
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_set_step675
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_set_step676
CMP	R1, #3
IT	EQ
BEQ	L___STEPPER4_Lib_set_step677
CMP	R1, #4
IT	EQ
BEQ	L___STEPPER4_Lib_set_step678
CMP	R1, #5
IT	EQ
BEQ	L___STEPPER4_Lib_set_step679
L___STEPPER4_Lib_set_step673:
;__STEPPER4_Lib.c,353 :: 		}
L_end_set_step6:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_step6
__STEPPER4_Lib_set_step8:
;__STEPPER4_Lib.c,355 :: 		static void set_step8(int32_t step)
; step start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; step end address is: 0 (R0)
; step start address is: 0 (R0)
;__STEPPER4_Lib.c,357 :: 		switch ( step & 0x07 )
AND	R1, R0, #7
; step end address is: 0 (R0)
STR	R1, [SP, #4]
IT	AL
BAL	L___STEPPER4_Lib_set_step880
;__STEPPER4_Lib.c,359 :: 		case 0 :
L___STEPPER4_Lib_set_step882:
;__STEPPER4_Lib.c,361 :: 		set_out_pins( 0b0001 );
MOVS	R0, #1
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,363 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,364 :: 		case 1 :
L___STEPPER4_Lib_set_step883:
;__STEPPER4_Lib.c,366 :: 		set_out_pins( 0b0101 );
MOVS	R0, #5
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,368 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,369 :: 		case 2 :
L___STEPPER4_Lib_set_step884:
;__STEPPER4_Lib.c,371 :: 		set_out_pins( 0b0100 );
MOVS	R0, #4
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,373 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,374 :: 		case 3 :
L___STEPPER4_Lib_set_step885:
;__STEPPER4_Lib.c,376 :: 		set_out_pins( 0b0110 );
MOVS	R0, #6
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,378 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,379 :: 		case 4 :
L___STEPPER4_Lib_set_step886:
;__STEPPER4_Lib.c,381 :: 		set_out_pins( 0b0010 );
MOVS	R0, #2
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,383 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,384 :: 		case 5 :
L___STEPPER4_Lib_set_step887:
;__STEPPER4_Lib.c,386 :: 		set_out_pins( 0b1010 );
MOVS	R0, #10
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,388 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,389 :: 		case 6 :
L___STEPPER4_Lib_set_step888:
;__STEPPER4_Lib.c,391 :: 		set_out_pins( 0b1000 );
MOVS	R0, #8
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,393 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,394 :: 		case 7:
L___STEPPER4_Lib_set_step889:
;__STEPPER4_Lib.c,396 :: 		set_out_pins( 0b1001 );
MOVS	R0, #9
BL	__STEPPER4_Lib_set_out_pins+0
;__STEPPER4_Lib.c,398 :: 		break;
IT	AL
BAL	L___STEPPER4_Lib_set_step881
;__STEPPER4_Lib.c,399 :: 		}
L___STEPPER4_Lib_set_step880:
LDR	R1, [SP, #4]
CMP	R1, #0
IT	EQ
BEQ	L___STEPPER4_Lib_set_step882
CMP	R1, #1
IT	EQ
BEQ	L___STEPPER4_Lib_set_step883
CMP	R1, #2
IT	EQ
BEQ	L___STEPPER4_Lib_set_step884
CMP	R1, #3
IT	EQ
BEQ	L___STEPPER4_Lib_set_step885
CMP	R1, #4
IT	EQ
BEQ	L___STEPPER4_Lib_set_step886
CMP	R1, #5
IT	EQ
BEQ	L___STEPPER4_Lib_set_step887
CMP	R1, #6
IT	EQ
BEQ	L___STEPPER4_Lib_set_step888
CMP	R1, #7
IT	EQ
BEQ	L___STEPPER4_Lib_set_step889
L___STEPPER4_Lib_set_step881:
;__STEPPER4_Lib.c,400 :: 		}
L_end_set_step8:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of __STEPPER4_Lib_set_step8
_STEPPER4_init:
;__STEPPER4_Lib.c,412 :: 		)
; use_en_pin start address is: 8 (R2)
; mcuFreq start address is: 4 (R1)
; ifacea start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
UXTH	R3, R1
SXTB	R1, R2
; use_en_pin end address is: 8 (R2)
; mcuFreq end address is: 4 (R1)
; ifacea end address is: 0 (R0)
; ifacea start address is: 0 (R0)
; mcuFreq start address is: 12 (R3)
; use_en_pin start address is: 4 (R1)
; enable_motor start address is: 8 (R2)
LDRSB	R2, [SP, #16]
;__STEPPER4_Lib.c,416 :: 		STEPPER4_init_hal( mcuFreq );
STRB	R2, [SP, #4]
; mcuFreq end address is: 12 (R3)
STRB	R1, [SP, #8]
STRB	R0, [SP, #12]
UXTH	R0, R3
BL	_STEPPER4_init_hal+0
LDRB	R0, [SP, #12]
LDRSB	R1, [SP, #8]
LDRSB	R2, [SP, #4]
;__STEPPER4_Lib.c,418 :: 		iface = ifacea;
MOVW	R4, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_iface+0)
STRB	R0, [R4, #0]
;__STEPPER4_Lib.c,419 :: 		pos_cur = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pos_cur+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,420 :: 		pos_tar = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pos_tar+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,421 :: 		speed = 0.0;
MOV	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,422 :: 		speed_max = 1.0;
MOV	R5, #1065353216
MOVW	R4, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_speed_max+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,423 :: 		acc = 0.0;
MOV	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_acc+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,424 :: 		sqrt_twoa = 1.0;
MOV	R5, #1065353216
MOVW	R4, #lo_addr(__STEPPER4_Lib_sqrt_twoa+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_sqrt_twoa+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,425 :: 		step_len = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,426 :: 		pw_min = 1;
MOVS	R5, #1
MOVW	R4, #lo_addr(__STEPPER4_Lib_pw_min+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pw_min+0)
STRH	R5, [R4, #0]
;__STEPPER4_Lib.c,427 :: 		st_last = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_st_last+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,428 :: 		en_pin = use_en_pin;
MOVW	R4, #lo_addr(__STEPPER4_Lib_en_pin+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_en_pin+0)
STRB	R1, [R4, #0]
; use_en_pin end address is: 4 (R1)
;__STEPPER4_Lib.c,429 :: 		n = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_n+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,430 :: 		c0 = 0.0;
MOV	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_c0+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_c0+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,431 :: 		cn = 0.0;
MOV	R5, #0
MOVW	R4, #lo_addr(__STEPPER4_Lib_cn+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_cn+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,432 :: 		cmin = 1.0;
MOV	R5, #1065353216
MOVW	R4, #lo_addr(__STEPPER4_Lib_cmin+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_cmin+0)
STR	R5, [R4, #0]
;__STEPPER4_Lib.c,433 :: 		dir = STEPPER4_DIR_CCW;
MOVS	R5, #0
SXTB	R5, R5
MOVW	R4, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_dir+0)
STRB	R5, [R4, #0]
;__STEPPER4_Lib.c,435 :: 		if ( iface == STEPPER4_mif_FULL4WIRE || iface == STEPPER4_mif_HALF4WIRE )
CMP	R0, #4
IT	EQ
BEQ	L__STEPPER4_init163
; ifacea end address is: 0 (R0)
MOVW	R4, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R4, [R4, #0]
CMP	R4, #8
IT	EQ
BEQ	L__STEPPER4_init162
IT	AL
BAL	L_STEPPER4_init92
L__STEPPER4_init163:
L__STEPPER4_init162:
;__STEPPER4_Lib.c,436 :: 		pins = 4;
MOVS	R5, #4
MOVW	R4, #lo_addr(__STEPPER4_Lib_pins+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pins+0)
STRB	R5, [R4, #0]
IT	AL
BAL	L_STEPPER4_init93
L_STEPPER4_init92:
;__STEPPER4_Lib.c,437 :: 		else if ( iface == STEPPER4_mif_FULL3WIRE || iface == STEPPER4_mif_HALF3WIRE )
MOVW	R4, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R4, [R4, #0]
CMP	R4, #3
IT	EQ
BEQ	L__STEPPER4_init165
MOVW	R4, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R4, [R4, #0]
CMP	R4, #6
IT	EQ
BEQ	L__STEPPER4_init164
IT	AL
BAL	L_STEPPER4_init96
L__STEPPER4_init165:
L__STEPPER4_init164:
;__STEPPER4_Lib.c,438 :: 		pins = 3;
MOVS	R5, #3
MOVW	R4, #lo_addr(__STEPPER4_Lib_pins+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pins+0)
STRB	R5, [R4, #0]
IT	AL
BAL	L_STEPPER4_init97
L_STEPPER4_init96:
;__STEPPER4_Lib.c,440 :: 		pins = 2;
MOVS	R5, #2
MOVW	R4, #lo_addr(__STEPPER4_Lib_pins+0)
MOVT	R4, #hi_addr(__STEPPER4_Lib_pins+0)
STRB	R5, [R4, #0]
L_STEPPER4_init97:
L_STEPPER4_init93:
;__STEPPER4_Lib.c,442 :: 		if( enable_motor )     ;
CMP	R2, #0
IT	EQ
BEQ	L_STEPPER4_init98
; enable_motor end address is: 8 (R2)
L_STEPPER4_init98:
;__STEPPER4_Lib.c,445 :: 		STEPPER4_set_acc( 1 );    // ovo ne vidim da treba
MOV	R0, #1065353216
BL	_STEPPER4_set_acc+0
;__STEPPER4_Lib.c,446 :: 		}
L_end_STEPPER4_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _STEPPER4_init
_STEPPER4_init_fp:
;__STEPPER4_Lib.c,448 :: 		void STEPPER4_init_fp(void(*fpforward )( ), void(*fpbackward)( ))
; fpbackward start address is: 4 (R1)
; fpforward start address is: 0 (R0)
SUB	SP, SP, #4
; fpbackward end address is: 4 (R1)
; fpforward end address is: 0 (R0)
; fpforward start address is: 0 (R0)
; fpbackward start address is: 4 (R1)
;__STEPPER4_Lib.c,450 :: 		fpfwd = fpforward;
MOVW	R2, #lo_addr(__STEPPER4_Lib_fpfwd+0)
MOVT	R2, #hi_addr(__STEPPER4_Lib_fpfwd+0)
STR	R0, [R2, #0]
; fpforward end address is: 0 (R0)
;__STEPPER4_Lib.c,451 :: 		fpbkwd = fpbackward;
MOVW	R2, #lo_addr(__STEPPER4_Lib_fpbkwd+0)
MOVT	R2, #hi_addr(__STEPPER4_Lib_fpbkwd+0)
STR	R1, [R2, #0]
; fpbackward end address is: 4 (R1)
;__STEPPER4_Lib.c,452 :: 		}
L_end_STEPPER4_init_fp:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_init_fp
_STEPPER4_move_to:
;__STEPPER4_Lib.c,454 :: 		void STEPPER4_move_to(int32_t position_abs)
; position_abs start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; position_abs end address is: 0 (R0)
; position_abs start address is: 0 (R0)
;__STEPPER4_Lib.c,456 :: 		if( pos_tar != position_abs )
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R1, [R1, #0]
CMP	R1, R0
IT	EQ
BEQ	L_STEPPER4_move_to99
;__STEPPER4_Lib.c,458 :: 		pos_tar = position_abs;
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_tar+0)
STR	R0, [R1, #0]
; position_abs end address is: 0 (R0)
;__STEPPER4_Lib.c,459 :: 		compute_speed();
BL	__STEPPER4_Lib_compute_speed+0
;__STEPPER4_Lib.c,460 :: 		}
L_STEPPER4_move_to99:
;__STEPPER4_Lib.c,461 :: 		}
L_end_STEPPER4_move_to:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_move_to
_STEPPER4_move:
;__STEPPER4_Lib.c,463 :: 		void STEPPER4_move(int32_t position_rel)
; position_rel start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; position_rel end address is: 0 (R0)
; position_rel start address is: 0 (R0)
;__STEPPER4_Lib.c,465 :: 		STEPPER4_move_to(pos_cur + position_rel);
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, R0
; position_rel end address is: 0 (R0)
MOV	R0, R1
BL	_STEPPER4_move_to+0
;__STEPPER4_Lib.c,466 :: 		}
L_end_STEPPER4_move:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_move
_STEPPER4_run:
;__STEPPER4_Lib.c,468 :: 		int8_t STEPPER4_run( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,470 :: 		if( STEPPER4_run_speed() )
BL	_STEPPER4_run_speed+0
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_run100
;__STEPPER4_Lib.c,471 :: 		compute_speed();
BL	__STEPPER4_Lib_compute_speed+0
L_STEPPER4_run100:
;__STEPPER4_Lib.c,473 :: 		return ( speed != 0.0 ) || ( STEPPER4_measure_dist( ) != 0 );
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R2, [R0, #0]
MOV	R0, #0
BL	__Compare_FP+0
MOVW	R0, #0
BEQ	L__STEPPER4_run194
MOVS	R0, #1
L__STEPPER4_run194:
CMP	R0, #0
IT	NE
BNE	L_STEPPER4_run102
BL	_STEPPER4_measure_dist+0
CMP	R0, #0
IT	NE
BNE	L_STEPPER4_run102
MOVS	R0, #0
IT	AL
BAL	L_STEPPER4_run101
L_STEPPER4_run102:
MOVS	R0, #1
L_STEPPER4_run101:
SXTB	R0, R0
;__STEPPER4_Lib.c,474 :: 		}
L_end_STEPPER4_run:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_run
_STEPPER4_run_speed:
;__STEPPER4_Lib.c,476 :: 		int8_t STEPPER4_run_speed( )
SUB	SP, SP, #8
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,484 :: 		if( !step_len )
MOVW	R0, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_step_len+0)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STEPPER4_run_speed103
;__STEPPER4_Lib.c,485 :: 		return false;
MOVS	R0, #0
SXTB	R0, R0
IT	AL
BAL	L_end_STEPPER4_run_speed
L_STEPPER4_run_speed103:
;__STEPPER4_Lib.c,487 :: 		time = STEPPER4_readMicros_hal();
BL	_STEPPER4_readMicros_hal+0
; time start address is: 12 (R3)
UXTH	R3, R0
;__STEPPER4_Lib.c,488 :: 		next_step_time = st_last + step_len;
MOVW	R0, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_step_len+0)
LDR	R1, [R0, #0]
MOVW	R2, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R2, #hi_addr(__STEPPER4_Lib_st_last+0)
LDR	R0, [R2, #0]
ADDS	R1, R0, R1
; next_step_time start address is: 16 (R4)
MOV	R4, R1
;__STEPPER4_Lib.c,491 :: 		( ( next_step_time < st_last ) && ( ( time >= next_step_time ) && ( time < st_last ) ) ) )
MOV	R0, R2
LDR	R0, [R0, #0]
CMP	R1, R0
IT	CC
BCC	L__STEPPER4_run_speed173
CMP	R3, R4
IT	CS
BCS	L__STEPPER4_run_speed172
MOVW	R0, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_st_last+0)
LDR	R0, [R0, #0]
CMP	R3, R0
IT	CC
BCC	L__STEPPER4_run_speed171
IT	AL
BAL	L__STEPPER4_run_speed169
; next_step_time end address is: 16 (R4)
L__STEPPER4_run_speed172:
L__STEPPER4_run_speed171:
IT	AL
BAL	L__STEPPER4_run_speed166
L__STEPPER4_run_speed169:
; next_step_time start address is: 16 (R4)
L__STEPPER4_run_speed173:
MOVW	R0, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_st_last+0)
LDR	R0, [R0, #0]
CMP	R4, R0
IT	CS
BCS	L__STEPPER4_run_speed174
CMP	R3, R4
IT	CC
BCC	L__STEPPER4_run_speed176
; next_step_time end address is: 16 (R4)
MOVW	R0, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_st_last+0)
LDR	R0, [R0, #0]
CMP	R3, R0
IT	CS
BCS	L__STEPPER4_run_speed175
L__STEPPER4_run_speed168:
IT	AL
BAL	L__STEPPER4_run_speed166
; time end address is: 12 (R3)
L__STEPPER4_run_speed176:
L__STEPPER4_run_speed175:
L__STEPPER4_run_speed174:
IT	AL
BAL	L_STEPPER4_run_speed114
L__STEPPER4_run_speed166:
;__STEPPER4_Lib.c,493 :: 		if ( dir == STEPPER4_DIR_CW )
; time start address is: 12 (R3)
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
LDRSB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_STEPPER4_run_speed115
;__STEPPER4_Lib.c,494 :: 		pos_cur += 1;
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
IT	AL
BAL	L_STEPPER4_run_speed116
L_STEPPER4_run_speed115:
;__STEPPER4_Lib.c,496 :: 		pos_cur -= 1;
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
L_STEPPER4_run_speed116:
;__STEPPER4_Lib.c,499 :: 		step( pos_cur );
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R0, [R0, #0]
STR	R3, [SP, #4]
BL	__STEPPER4_Lib_step+0
LDR	R3, [SP, #4]
;__STEPPER4_Lib.c,501 :: 		st_last = time;
MOVW	R0, #lo_addr(__STEPPER4_Lib_st_last+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_st_last+0)
STR	R3, [R0, #0]
; time end address is: 12 (R3)
;__STEPPER4_Lib.c,503 :: 		return true;
MOVS	R0, #1
SXTB	R0, R0
IT	AL
BAL	L_end_STEPPER4_run_speed
;__STEPPER4_Lib.c,504 :: 		}
L_STEPPER4_run_speed114:
;__STEPPER4_Lib.c,507 :: 		return false;
MOVS	R0, #0
SXTB	R0, R0
;__STEPPER4_Lib.c,509 :: 		}
L_end_STEPPER4_run_speed:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _STEPPER4_run_speed
_STEPPER4_measure_dist:
;__STEPPER4_Lib.c,511 :: 		int32_t STEPPER4_measure_dist( )
SUB	SP, SP, #4
;__STEPPER4_Lib.c,513 :: 		return pos_tar - pos_cur;
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R0, [R0, #0]
SUB	R0, R0, R1
;__STEPPER4_Lib.c,514 :: 		}
L_end_STEPPER4_measure_dist:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_measure_dist
_STEPPER4_read_tar_pos:
;__STEPPER4_Lib.c,516 :: 		int32_t STEPPER4_read_tar_pos( )
SUB	SP, SP, #4
;__STEPPER4_Lib.c,518 :: 		return pos_tar;
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R0, [R0, #0]
;__STEPPER4_Lib.c,519 :: 		}
L_end_STEPPER4_read_tar_pos:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_read_tar_pos
_STEPPER4_read_cur_pos:
;__STEPPER4_Lib.c,521 :: 		int32_t STEPPER4_read_cur_pos()
SUB	SP, SP, #4
;__STEPPER4_Lib.c,523 :: 		return pos_cur;
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R0, [R0, #0]
;__STEPPER4_Lib.c,524 :: 		}
L_end_STEPPER4_read_cur_pos:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_read_cur_pos
_STEPPER4_set_cur_pos:
;__STEPPER4_Lib.c,526 :: 		void STEPPER4_set_cur_pos(int32_t position)
; position start address is: 0 (R0)
SUB	SP, SP, #4
; position end address is: 0 (R0)
; position start address is: 0 (R0)
;__STEPPER4_Lib.c,528 :: 		pos_tar = pos_cur = position;
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_cur+0)
STR	R0, [R1, #0]
MOVW	R1, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pos_tar+0)
STR	R0, [R1, #0]
; position end address is: 0 (R0)
;__STEPPER4_Lib.c,529 :: 		n = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
STR	R2, [R1, #0]
;__STEPPER4_Lib.c,530 :: 		step_len = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R2, [R1, #0]
;__STEPPER4_Lib.c,531 :: 		speed = 0;
MOV	R2, #0
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R2, [R1, #0]
;__STEPPER4_Lib.c,532 :: 		}
L_end_STEPPER4_set_cur_pos:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_set_cur_pos
_STEPPER4_set_max_speed:
;__STEPPER4_Lib.c,534 :: 		void STEPPER4_set_max_speed(float speed)
; speed start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
MOV	R8, R0
; speed end address is: 0 (R0)
; speed start address is: 32 (R8)
;__STEPPER4_Lib.c,536 :: 		if( speed_max != speed )
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
LDR	R0, [R1, #0]
MOV	R2, R8
BL	__Compare_FP+0
MOVW	R0, #0
BEQ	L__STEPPER4_set_max_speed201
MOVS	R0, #1
L__STEPPER4_set_max_speed201:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_max_speed118
;__STEPPER4_Lib.c,538 :: 		speed_max = speed;
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
STR	R8, [R1, #0]
;__STEPPER4_Lib.c,539 :: 		cmin = 1000000.0 / speed;
MOVW	R0, #9216
MOVT	R0, #18804
MOV	R2, R8
BL	__Div_FP+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_cmin+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_cmin+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,541 :: 		if( n > 0 )
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
LDR	R1, [R1, #0]
CMP	R1, #0
IT	LE
BLE	L_STEPPER4_set_max_speed119
;__STEPPER4_Lib.c,543 :: 		n = ( int32_t )( ( speed * speed ) / ( 2.0 * acc ) );
MOV	R0, R8
MOV	R2, R8
BL	__Mul_FP+0
; speed end address is: 32 (R8)
STR	R0, [SP, #12]
MOVW	R1, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_acc+0)
LDR	R2, [R1, #0]
MOV	R0, #1073741824
BL	__Mul_FP+0
STR	R0, [SP, #8]
LDR	R0, [SP, #12]
STR	R1, [SP, #4]
LDR	R1, [SP, #8]
MOV	R2, R1
BL	__Div_FP+0
LDR	R1, [SP, #4]
BL	__FloatToSignedIntegral+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,544 :: 		compute_speed();
BL	__STEPPER4_Lib_compute_speed+0
;__STEPPER4_Lib.c,545 :: 		}
L_STEPPER4_set_max_speed119:
;__STEPPER4_Lib.c,546 :: 		}
L_STEPPER4_set_max_speed118:
;__STEPPER4_Lib.c,547 :: 		}
L_end_STEPPER4_set_max_speed:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _STEPPER4_set_max_speed
_STEPPER4_set_acc:
;__STEPPER4_Lib.c,549 :: 		void STEPPER4_set_acc(float acceleration)
; acceleration start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
MOV	R12, R0
; acceleration end address is: 0 (R0)
; acceleration start address is: 48 (R12)
;__STEPPER4_Lib.c,551 :: 		if( acc == 0.0 )
MOVW	R1, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_acc+0)
LDR	R2, [R1, #0]
MOV	R0, #0
BL	__Compare_FP+0
MOVW	R0, #0
BNE	L__STEPPER4_set_acc203
MOVS	R0, #1
L__STEPPER4_set_acc203:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_acc120
; acceleration end address is: 48 (R12)
;__STEPPER4_Lib.c,552 :: 		return;
IT	AL
BAL	L_end_STEPPER4_set_acc
L_STEPPER4_set_acc120:
;__STEPPER4_Lib.c,554 :: 		if( acc != acceleration )
; acceleration start address is: 48 (R12)
MOVW	R1, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_acc+0)
LDR	R0, [R1, #0]
MOV	R2, R12
BL	__Compare_FP+0
MOVW	R0, #0
BEQ	L__STEPPER4_set_acc204
MOVS	R0, #1
L__STEPPER4_set_acc204:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_acc121
;__STEPPER4_Lib.c,556 :: 		n = n * ( acc / acceleration );
MOVW	R1, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_acc+0)
STR	R1, [SP, #12]
LDR	R0, [R1, #0]
MOV	R2, R12
BL	__Div_FP+0
STR	R0, [SP, #8]
MOVW	R1, #lo_addr(__STEPPER4_Lib_n+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_n+0)
STR	R1, [SP, #4]
LDR	R0, [R1, #0]
BL	__SignedIntegralToFloat+0
LDR	R2, [SP, #8]
BL	__Mul_FP+0
BL	__FloatToSignedIntegral+0
LDR	R1, [SP, #4]
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,557 :: 		c0 = 0.676 * sqrt( 2.0 / acceleration ) * 1000000.0;
MOV	R0, #1073741824
MOV	R2, R12
BL	__Div_FP+0
BL	_sqrt+0
MOVW	R2, #3670
MOVT	R2, #16173
BL	__Mul_FP+0
MOVW	R2, #9216
MOVT	R2, #18804
BL	__Mul_FP+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_c0+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_c0+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,558 :: 		acc = acceleration;
LDR	R1, [SP, #12]
STR	R12, [R1, #0]
; acceleration end address is: 48 (R12)
;__STEPPER4_Lib.c,560 :: 		compute_speed();
BL	__STEPPER4_Lib_compute_speed+0
;__STEPPER4_Lib.c,561 :: 		}
L_STEPPER4_set_acc121:
;__STEPPER4_Lib.c,562 :: 		}
L_end_STEPPER4_set_acc:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _STEPPER4_set_acc
_STEPPER4_set_speed:
;__STEPPER4_Lib.c,564 :: 		void STEPPER4_set_speed(float speedf) // dodao sam f da bi se razlikovala od globalne speed
; speedf start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R3, R0
; speedf end address is: 0 (R0)
; speedf start address is: 12 (R3)
;__STEPPER4_Lib.c,566 :: 		if( speedf == speed )
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R0, [R1, #0]
MOV	R2, R3
BL	__Compare_FP+0
MOVW	R0, #0
BNE	L__STEPPER4_set_speed206
MOVS	R0, #1
L__STEPPER4_set_speed206:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_speed122
; speedf end address is: 12 (R3)
;__STEPPER4_Lib.c,567 :: 		return;
IT	AL
BAL	L_end_STEPPER4_set_speed
L_STEPPER4_set_speed122:
;__STEPPER4_Lib.c,569 :: 		speedf = CONSTRAIN( speedf, -speed_max, speed_max );
; speedf start address is: 12 (R3)
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
LDR	R1, [R1, #0]
EOR	R0, R1, #-2147483648
MOV	R2, R3
BL	__Compare_FP+0
MOVW	R0, #0
BLE	L__STEPPER4_set_speed207
MOVS	R0, #1
L__STEPPER4_set_speed207:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_speed123
; speedf end address is: 12 (R3)
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
LDR	R1, [R1, #0]
EOR	R1, R1, #-2147483648
; ?FLOC___STEPPER4_set_speed?T145 start address is: 4 (R1)
; ?FLOC___STEPPER4_set_speed?T145 end address is: 4 (R1)
IT	AL
BAL	L_STEPPER4_set_speed124
L_STEPPER4_set_speed123:
; speedf start address is: 12 (R3)
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
LDR	R0, [R1, #0]
MOV	R2, R3
BL	__Compare_FP+0
MOVW	R0, #0
BGE	L__STEPPER4_set_speed208
MOVS	R0, #1
L__STEPPER4_set_speed208:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_speed125
; speedf end address is: 12 (R3)
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed_max+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed_max+0)
; ?FLOC___STEPPER4_set_speed?T147 start address is: 4 (R1)
LDR	R1, [R1, #0]
; ?FLOC___STEPPER4_set_speed?T147 end address is: 4 (R1)
IT	AL
BAL	L_STEPPER4_set_speed126
L_STEPPER4_set_speed125:
; ?FLOC___STEPPER4_set_speed?T147 start address is: 0 (R0)
; speedf start address is: 12 (R3)
MOV	R0, R3
; speedf end address is: 12 (R3)
; ?FLOC___STEPPER4_set_speed?T147 end address is: 0 (R0)
MOV	R1, R0
L_STEPPER4_set_speed126:
; ?FLOC___STEPPER4_set_speed?T147 start address is: 4 (R1)
; ?FLOC___STEPPER4_set_speed?T145 start address is: 0 (R0)
MOV	R0, R1
; ?FLOC___STEPPER4_set_speed?T147 end address is: 4 (R1)
; ?FLOC___STEPPER4_set_speed?T145 end address is: 0 (R0)
MOV	R1, R0
L_STEPPER4_set_speed124:
; ?FLOC___STEPPER4_set_speed?T145 start address is: 4 (R1)
; speedf start address is: 32 (R8)
MOV	R8, R1
;__STEPPER4_Lib.c,571 :: 		if( speedf == 0.0 )
MOV	R0, #0
MOV	R2, R1
BL	__Compare_FP+0
MOVW	R0, #0
BNE	L__STEPPER4_set_speed209
MOVS	R0, #1
L__STEPPER4_set_speed209:
; ?FLOC___STEPPER4_set_speed?T145 end address is: 4 (R1)
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_speed127
;__STEPPER4_Lib.c,573 :: 		step_len = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R2, [R1, #0]
;__STEPPER4_Lib.c,574 :: 		}
IT	AL
BAL	L_STEPPER4_set_speed128
L_STEPPER4_set_speed127:
;__STEPPER4_Lib.c,577 :: 		step_len = fabs( 1000000.0 / speedf );
MOVW	R0, #9216
MOVT	R0, #18804
MOV	R2, R8
BL	__Div_FP+0
BL	_fabs+0
BL	__FloatToUnsignedIntegral+0
MOVW	R1, #lo_addr(__STEPPER4_Lib_step_len+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_step_len+0)
STR	R0, [R1, #0]
;__STEPPER4_Lib.c,578 :: 		dir = ( speedf > 0.0 ) ? STEPPER4_DIR_CW : STEPPER4_DIR_CCW;
MOV	R0, #0
MOV	R2, R8
BL	__Compare_FP+0
MOVW	R0, #0
BGE	L__STEPPER4_set_speed210
MOVS	R0, #1
L__STEPPER4_set_speed210:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_set_speed129
; ?FLOC___STEPPER4_set_speed?T152 start address is: 0 (R0)
MOVS	R0, #1
; ?FLOC___STEPPER4_set_speed?T152 end address is: 0 (R0)
IT	AL
BAL	L_STEPPER4_set_speed130
L_STEPPER4_set_speed129:
; ?FLOC___STEPPER4_set_speed?T152 start address is: 0 (R0)
MOVS	R0, #0
; ?FLOC___STEPPER4_set_speed?T152 end address is: 0 (R0)
L_STEPPER4_set_speed130:
; ?FLOC___STEPPER4_set_speed?T152 start address is: 0 (R0)
MOVW	R1, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_dir+0)
STRB	R0, [R1, #0]
; ?FLOC___STEPPER4_set_speed?T152 end address is: 0 (R0)
;__STEPPER4_Lib.c,579 :: 		}
L_STEPPER4_set_speed128:
;__STEPPER4_Lib.c,581 :: 		speed = speedf;
MOVW	R1, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R8, [R1, #0]
; speedf end address is: 32 (R8)
;__STEPPER4_Lib.c,582 :: 		}
L_end_STEPPER4_set_speed:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_set_speed
_STEPPER4_read_speed:
;__STEPPER4_Lib.c,584 :: 		float STEPPER4_read_speed( )
SUB	SP, SP, #4
;__STEPPER4_Lib.c,586 :: 		return speed;
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R0, [R0, #0]
;__STEPPER4_Lib.c,587 :: 		}
L_end_STEPPER4_read_speed:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_read_speed
_STEPPER4_disable_outputs:
;__STEPPER4_Lib.c,589 :: 		void STEPPER4_disable_outputs( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,591 :: 		if( !iface )
MOVW	R0, #lo_addr(__STEPPER4_Lib_iface+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_iface+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STEPPER4_disable_outputs131
;__STEPPER4_Lib.c,592 :: 		return;
IT	AL
BAL	L_end_STEPPER4_disable_outputs
L_STEPPER4_disable_outputs131:
;__STEPPER4_Lib.c,594 :: 		if( en_pin )
MOVW	R0, #lo_addr(__STEPPER4_Lib_en_pin+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_en_pin+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_disable_outputs132
;__STEPPER4_Lib.c,595 :: 		STEPPER4_enable_hal( 0 );
MOVS	R0, #0
BL	_STEPPER4_enable_hal+0
IT	AL
BAL	L_STEPPER4_disable_outputs133
L_STEPPER4_disable_outputs132:
;__STEPPER4_Lib.c,597 :: 		return;
IT	AL
BAL	L_end_STEPPER4_disable_outputs
L_STEPPER4_disable_outputs133:
;__STEPPER4_Lib.c,598 :: 		}
L_end_STEPPER4_disable_outputs:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_disable_outputs
_STEPPER4_run_to_position:
;__STEPPER4_Lib.c,600 :: 		void STEPPER4_run_to_position( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,602 :: 		while( STEPPER4_run() );
L_STEPPER4_run_to_position134:
BL	_STEPPER4_run+0
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_run_to_position135
IT	AL
BAL	L_STEPPER4_run_to_position134
L_STEPPER4_run_to_position135:
;__STEPPER4_Lib.c,603 :: 		}
L_end_STEPPER4_run_to_position:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_run_to_position
_STEPPER4_run_speed_to_position:
;__STEPPER4_Lib.c,605 :: 		int8_t STEPPER4_run_speed_to_position( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,607 :: 		if( pos_tar == pos_cur )
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R0, [R0, #0]
CMP	R0, R1
IT	NE
BNE	L_STEPPER4_run_speed_to_position136
;__STEPPER4_Lib.c,608 :: 		return false;
MOVS	R0, #0
SXTB	R0, R0
IT	AL
BAL	L_end_STEPPER4_run_speed_to_position
L_STEPPER4_run_speed_to_position136:
;__STEPPER4_Lib.c,610 :: 		if( pos_tar > pos_cur )
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R0, [R0, #0]
CMP	R0, R1
IT	LE
BLE	L_STEPPER4_run_speed_to_position137
;__STEPPER4_Lib.c,611 :: 		dir = STEPPER4_DIR_CW;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
STRB	R1, [R0, #0]
IT	AL
BAL	L_STEPPER4_run_speed_to_position138
L_STEPPER4_run_speed_to_position137:
;__STEPPER4_Lib.c,613 :: 		dir = STEPPER4_DIR_CCW;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(__STEPPER4_Lib_dir+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_dir+0)
STRB	R1, [R0, #0]
L_STEPPER4_run_speed_to_position138:
;__STEPPER4_Lib.c,615 :: 		return STEPPER4_run_speed();
BL	_STEPPER4_run_speed+0
;__STEPPER4_Lib.c,616 :: 		}
L_end_STEPPER4_run_speed_to_position:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_run_speed_to_position
_STEPPER4_run_to_new_position:
;__STEPPER4_Lib.c,618 :: 		void STEPPER4_run_to_new_position(int32_t position)
; position start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; position end address is: 0 (R0)
; position start address is: 0 (R0)
;__STEPPER4_Lib.c,620 :: 		STEPPER4_move_to( position );
; position end address is: 0 (R0)
BL	_STEPPER4_move_to+0
;__STEPPER4_Lib.c,621 :: 		STEPPER4_run_to_position();
BL	_STEPPER4_run_to_position+0
;__STEPPER4_Lib.c,622 :: 		}
L_end_STEPPER4_run_to_new_position:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_run_to_new_position
_STEPPER4_stop:
;__STEPPER4_Lib.c,624 :: 		void STEPPER4_stop( )
SUB	SP, SP, #20
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,628 :: 		if( speed != 0.0 )
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R2, [R0, #0]
MOV	R0, #0
BL	__Compare_FP+0
MOVW	R0, #0
BEQ	L__STEPPER4_stop217
MOVS	R0, #1
L__STEPPER4_stop217:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_stop139
;__STEPPER4_Lib.c,630 :: 		sts = ( int32_t )( ( speed * speed ) / ( 2.0 * acc ) ) + 1;
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
STR	R0, [SP, #16]
LDR	R2, [R0, #0]
LDR	R0, [R0, #0]
BL	__Mul_FP+0
STR	R0, [SP, #12]
MOVW	R0, #lo_addr(__STEPPER4_Lib_acc+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_acc+0)
LDR	R2, [R0, #0]
MOV	R0, #1073741824
BL	__Mul_FP+0
STR	R0, [SP, #8]
LDR	R0, [SP, #12]
STR	R1, [SP, #4]
LDR	R1, [SP, #8]
MOV	R2, R1
BL	__Div_FP+0
LDR	R1, [SP, #4]
BL	__FloatToSignedIntegral+0
ADDS	R0, R0, #1
; sts start address is: 36 (R9)
MOV	R9, R0
;__STEPPER4_Lib.c,632 :: 		if( speed > 0 )
LDR	R0, [SP, #16]
LDR	R2, [R0, #0]
MOV	R0, #0
BL	__Compare_FP+0
MOVW	R0, #0
BGE	L__STEPPER4_stop218
MOVS	R0, #1
L__STEPPER4_stop218:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_stop140
;__STEPPER4_Lib.c,633 :: 		STEPPER4_move( sts );
MOV	R0, R9
; sts end address is: 36 (R9)
BL	_STEPPER4_move+0
IT	AL
BAL	L_STEPPER4_stop141
L_STEPPER4_stop140:
;__STEPPER4_Lib.c,635 :: 		STEPPER4_move( -sts );
; sts start address is: 36 (R9)
RSB	R0, R9, #0
; sts end address is: 36 (R9)
BL	_STEPPER4_move+0
L_STEPPER4_stop141:
;__STEPPER4_Lib.c,636 :: 		}
L_STEPPER4_stop139:
;__STEPPER4_Lib.c,638 :: 		if( en_pin )
MOVW	R0, #lo_addr(__STEPPER4_Lib_en_pin+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_en_pin+0)
LDRSB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_stop142
;__STEPPER4_Lib.c,639 :: 		STEPPER4_enable_hal( 1 );
MOVS	R0, #1
BL	_STEPPER4_enable_hal+0
L_STEPPER4_stop142:
;__STEPPER4_Lib.c,640 :: 		}
L_end_STEPPER4_stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _STEPPER4_stop
_STEPPER4_set_min_pulse_width:
;__STEPPER4_Lib.c,642 :: 		void STEPPER4_set_min_pulse_width(uint16_t width)
; width start address is: 0 (R0)
SUB	SP, SP, #4
; width end address is: 0 (R0)
; width start address is: 0 (R0)
;__STEPPER4_Lib.c,644 :: 		pw_min = width;
MOVW	R1, #lo_addr(__STEPPER4_Lib_pw_min+0)
MOVT	R1, #hi_addr(__STEPPER4_Lib_pw_min+0)
STRH	R0, [R1, #0]
; width end address is: 0 (R0)
;__STEPPER4_Lib.c,645 :: 		}
L_end_STEPPER4_set_min_pulse_width:
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_set_min_pulse_width
_STEPPER4_is_running:
;__STEPPER4_Lib.c,647 :: 		int8_t STEPPER4_is_running( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__STEPPER4_Lib.c,649 :: 		return !( speed == 0.0 && pos_tar == pos_cur );
MOVW	R0, #lo_addr(__STEPPER4_Lib_speed+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_speed+0)
LDR	R2, [R0, #0]
MOV	R0, #0
BL	__Compare_FP+0
MOVW	R0, #0
BNE	L__STEPPER4_is_running221
MOVS	R0, #1
L__STEPPER4_is_running221:
CMP	R0, #0
IT	EQ
BEQ	L_STEPPER4_is_running144
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_cur+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_cur+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(__STEPPER4_Lib_pos_tar+0)
MOVT	R0, #hi_addr(__STEPPER4_Lib_pos_tar+0)
LDR	R0, [R0, #0]
CMP	R0, R1
IT	NE
BNE	L_STEPPER4_is_running144
MOVS	R0, #1
IT	AL
BAL	L_STEPPER4_is_running143
L_STEPPER4_is_running144:
MOVS	R0, #0
L_STEPPER4_is_running143:
CMP	R0, #0
MOVW	R0, #0
BNE	L__STEPPER4_is_running222
MOVS	R0, #1
L__STEPPER4_is_running222:
SXTB	R0, R0
;__STEPPER4_Lib.c,651 :: 		}
L_end_STEPPER4_is_running:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STEPPER4_is_running
